struct block {
  result_t (*read)(struct ures *ur, char *buffer, 
		   count_t block_start, 
		   count_t *inout_block_count);
  result_t (*write)(struct ures *ur, const char *buffer, 
		    count_t block_start, 
		    count_t *inout_block_count);
  result_t (*get_device_size)(const struct ures *ur, 
			      size_t *out_block_size, 
			      count_t *out_block_count);
  result_t (*ctrl_lock)(struct ures *ur, block_lock_op_t op_type,
			count_t block_start);
};
