#include "kos-interfaces.h"
#include "syscall.h"

[...]

/* Interface block */
result_t __kos_sys_block_read (int __rd__, char* buffer, count_t block_start, count_t* inout_block_count)
{
  return __kos_do_syscall3 (__rd__, KOS_INTERFACE_BLOCK_READ,
		(unsigned long)buffer,
		(unsigned long)block_start,
		(unsigned long)inout_block_count);
}

result_t __kos_sys_block_write (int __rd__, const char* buffer, count_t block_start, count_t* inout_block_count)
{
  return __kos_do_syscall3 (__rd__, KOS_INTERFACE_BLOCK_WRITE,
		(unsigned long)buffer,
		(unsigned long)block_start,
		(unsigned long)inout_block_count);
}

result_t __kos_sys_block_get_device_size (int __rd__, size_t* out_block_size, count_t* out_block_count)
{
  return __kos_do_syscall2 (__rd__, KOS_INTERFACE_BLOCK_GET_DEVICE_SIZE,
		(unsigned long)out_block_size,
		(unsigned long)out_block_count);
}

[...]
